""" Example code for pyCairo, generate animation on click """
import rsvg
import cairo
from interface import register, drawingArea, main, redraw_all

sx = 800
sy = 600
px = 100.0
py = 400.0
sc = 2
tr = 25 * sc
pw = 50 * sc
ph = 50 * sc
dx = 2
dy = 2
last = None
svgf = "plugin-compiztoolbox.svg"
svg = rsvg.Handle(file=svgf)
#img = cairo.ImageSurface.create_from_png("gtk.png")


def cb_click(x, y):
    """ mouse handler """
    if x >= px and x <= px + pw and y >= py and y <= py + ph:
        print "clicked"


def cb_redraw(ctx):
    """ animate an image """
    try:
        matrix = cairo.Matrix(sc, 0, 0, sc, 0, 0)
        matrix.translate(px / sc + tr, py / sc + tr)
        matrix.rotate(py / 100.0)
        matrix.translate(-tr, -tr)
        ctx.transform(matrix)
        svg.render_cairo(ctx)
    except cairo.Error, e:
        print e


def cb_timer(area):
    """ timer function for animations """
    global px, py, dx, dy
    px += dx
    py += dy
    if px + pw >= sx:
        px = sx - pw
        dx *= -1
    if px <= 0:
        px = 0
        dx *= -1
    if py + ph >= sy:
        py = sy - ph
        dy *= -1
    if py <= 0:
        py = 0
        dy *= -1
    redraw_all()


if __name__ == "__main__":
    register(None, cb_click, cb_redraw, cb_timer)
    drawingArea()
    main()
