""" Show how to use closures """


def fn(a):
    """ The simpele closure """
    def inner(b):
        """ Inner function that is returned, could be anonymous """
        return a * b
    return inner

print "Calculate closure:", fn(2)(3)


def fn_anonymous(a):
    """ Even shorter """
    return lambda b: a * b

print "Calculate again:", fn_anonymous(2)(3)


def cb_click(s):
    """ General click function """
    def cb_general_click(area, time):
        """ General actions """
        if s != None:
            s()
    return cb_general_click


def special():
    """ Special handling for a situation """

# part1.connect("button-press-event", cb_mouse(None))
# part2.connect("button-press-event", cb_mouse(special))


l = ['1', '21', '12']
l.sort(cmp=lambda a, b: cmp(int(a), int(b)))
print "Sorting numbers:", l
l = ['1', '21', '12']
print "Easier:", sorted(l, key=int)

l = ['What', 'a', 'Big', 'problem']
print "Not correctly sorted:", sorted(l)
print "Better sorted:", sorted(l, cmp=lambda a, b: cmp(a.lower(), b.lower()))
print "Easier:", sorted(l, key=str.lower)
