""" Show different error handling situations """
import sys
import traceback

try:
    a = 1 / 0
except ZeroDivisionError:
    print "Divide by zero"
print

try:
    a = int("a")
except ValueError:
    print "Value error"
print

try:
    ['a'].index(2)
except ValueError:
    print "Index out of bound"
finally:
    print "Allways show"
print

try:
    a = 4
except (ValueError, NameError):
    print "Houston we have a problem"
else:
    print "Everything is OK"
print

try:
    open("nothing.txt", "r")
except IOError as err:
    print "Type:", type(err)
    print "Error string:", err.strerror
    print "Filename:", err.filename
    print "Arguments:", err.args
    print "As string:", err
    print
    print "Last traceback:"
    traceback.print_tb(sys.exc_info()[2])

# get information about the error: help(IOError)
