""" Enumeration example """


def enumValues(tp):
    """ Return defined enumeration values """
    if not hasattr(tp, "values"):
        fillEnum(tp)
    return tp.values


def fillEnum(tp):
    """ Fill the values structure for this enumerate type """
    tp.values = sorted([
        d for d in tp.__dict__.iteritems() if isinstance(d[1], int)
    ], key=lambda d: d[1])


def enumValue(tp, nr):
    """ Return the nr value """
    if not hasattr(tp, "values"):
        fillEnum(tp)
    return binary_search(tp.values, nr,
        lambda x, y: -1 if x[1] < y else 1 if x[1] > y else 0)[0]


def enumOrd(tp, value):
    """ Return the number by the given value """
    try:
        return tp.__dict__[value]
    except KeyError:
        return None


def binary_search(a, x, compare, lo=0, hi=None):
    """ General binary search algorithm """
    if hi == None:
        hi = len(a)
    while lo < hi:
        mid = (lo + hi) // 2
        midval = a[mid]
        if compare(midval, x) < 0:
            lo = mid + 1
        elif compare(midval, x) > 0:
            hi = mid
        else:
            return a[mid]
    return (None, 0)


class Days:
    """ Weekdays """
    Monday = 1
    Tuesday = 2
    Wednesday = 3
    Thursday = 4
    Friday = 5
    Saturday = 6
    Sunday = 7


class Words:
    """ Words """
    Aap = 0
    Noot = 12
    Mies = 200
    Zus = 210

print "Constant:", Days.Friday

print "List of tuples:"
for day in enumValues(Days):
    print day

print "String from number:", enumValue(Days, 5)
print "Number from string:", enumOrd(Days, "Thursday")
print "Unknown string:", enumOrd(Days, "Sunnday")
print "String from number:", enumValue(Words, 12)
print "Unknown number:", enumValue(Words, 112)
