""" Show reflection inside python """
import inspect
import types


class Test():
    """ A class to inspect """
    def __init__(self, name):
        self.name = name

    def show(self):
        """ Show normally """
        print self.name

    def special(self, superlative="strong"):
        """ Show with superlative """
        print "<" + superlative + ">", self.name, "</" + superlative + ">"

    def combine(self, before="not really", after="after all"):
        """ Show it with start and finish """
        print before, self.name, after

t = Test("me")

for key, data in inspect.getmembers(t):
    if isinstance(data, types.MethodType):
        spec = inspect.getargspec(data)
        print 'Function:', key, spec.args, spec.defaults, data.__doc__
        if len(spec.args) == 1 or (spec.defaults != None and
                                   len(spec.args) == len(spec.defaults) + 1):
            print "Result:",
            data()
    if key == '__doc__':
        print "Documentation:", data
